#!/bin/sh
 #
 # 第一次执行它的时候它会检查是否有完全备份,否则先创建一个全库备份
# 当你再次运行它的时候,它会根据脚本中的设定来基于之前的全库备份进行增量备份

 
INNOBACKUPEX_PATH=innobackupex #INNOBACKUPEX的命令
INNOBACKUPEXFULL=/usr/bin/$INNOBACKUPEX_PATH #INNOBACKUPEX的命令路径
 
#mysql目标服务器以及用户名和密码
MYSQL_CMD="--host=192.16.2.11 --user=root --password=123456 --port=3306"
 
MYSQL_UP="--user=root --password=123456 -p3306" #mysql的用户名和密码
 
TMPLOG="/tmp/innobackupex.$$.log"
 
MY_CNF=/etc/my.cnf #mysql的配置文件
 
MYSQL=/usr/bin/mysql
 
MYSQL_ADMIN=/usr/bin/mysqladmin
 
BACKUP_DIR=/backup # 备份的主目录
 
FULLBACKUP_DIR=$BACKUP_DIR/full # 全库备份的目录
 
INCRBACKUP_DIR=$BACKUP_DIR/incre # 增量备份的目录
 
FULLBACKUP_INTERVAL=259200 # 全库备份的间隔周期,时间:秒
 
KEEP_FULLBACKUP=1 # 至少保留几个全库备份
 
logfiledate=backup.`date +%Y%m%d%H%M`.txt
 
#开始时间
STARTED_TIME=`date +%s`
#date +%s从 1970 年 1 月 1 日 00:00:00 UTC 到目前为止的秒数
 
 
#############################################################################
 
# 显示错误并退出
 
#############################################################################
 
error()
 {
     echo "$1" 1>&2
     exit 1
 }
 
 
 
# 检查执行环境
 
if [ ! -x $INNOBACKUPEXFULL ]; then
   error "$INNOBACKUPEXFULL未安装或未链接到/usr/bin."
 fi
#-x 测试是否有执行权限
 
 
if [ ! -d $BACKUP_DIR ]; then
   error "备份目标文件夹:$BACKUP_DIR不存在."
fi
 
 
 
if [ -z "`$MYSQL_ADMIN $MYSQL_UP status | grep 'Uptime'`" ] ; then
  error "MySQL 没有启动运行."
fi
 
 #-z 空字符串
 
 
 
if ! `echo 'exit' | $MYSQL -s $MYSQL_CMD` ; then
  error "提供的数据库用户名或密码不正确!"
fi
 
#mysql -s, --silent //一行一行输出,中间用tab分隔
 
 
# 备份的头部信息
 
echo "----------------------------"
echo
 echo "$0: MySQL备份脚本"
echo "开始于: `date +%F' '%T' '%w`"
 echo
#上面的$0 表示当前运行的进程名或是当前执行的脚本名
 
 
#新建全备和差异备份的目录
 
mkdir -p $FULLBACKUP_DIR
mkdir -p $INCRBACKUP_DIR
 
 
 
#查找最新的完全备份
LATEST_FULL_BACKUP=`find $FULLBACKUP_DIR -mindepth 1 -maxdepth 1 -type d -printf "%P\n" | sort -nr | head -1`
 
#-mindepthd 1,表示从$FULLBACKUP_DIR目录的第0层开始查;-maxdepth 1,表示列出$FULLBACKUP_DIR内的文件时深度最多为0层
 
 
# 查找最近修改的最新备份
 
LATEST_FULL_BACKUP_CREATED_TIME=`stat -c %Y $FULLBACKUP_DIR/$LATEST_FULL_BACKUP`
#stat -c %Y 获取文件的修改时间
 
 #如果全备有效进行增量备份否则执行完全备份
if [ "$LATEST_FULL_BACKUP" -a `expr $LATEST_FULL_BACKUP_CREATED_TIME + $FULLBACKUP_INTERVAL + 5` -ge $STARTED_TIME ] ; then
 # 如果最新的全备未过期则以最新的全备文件名命名在增量备份目录下新建目录
echo -e "完全备份$LATEST_FULL_BACKUP未过期,将根据$LATEST_FULL_BACKUP名字作为增量备份目录命名"
echo " "
 NEW_INCRDIR=$INCRBACKUP_DIR/$LATEST_FULL_BACKUP
 mkdir -p $NEW_INCRDIR
 
 
 
# 查找最新的增量备份是否存在.指定一个备份的路径作为增量备份的基础
LATEST_INCR_BACKUP=`find $NEW_INCRDIR -mindepth 1 -maxdepth 1 -type d | sort -nr | head -1`
 
if [ ! $LATEST_INCR_BACKUP ] ; then
 INCRBASEDIR=$FULLBACKUP_DIR/$LATEST_FULL_BACKUP
 echo -e "增量备份将以$INCRBASEDIR作为备份基础"
echo " "
 else
 INCRBASEDIR=$LATEST_INCR_BACKUP
 echo -e "增量备份将以$INCRBASEDIR作为备份基础"
echo " "
 fi
 
 
 
echo "使用$INCRBASEDIR作为基础做新的增量备份."
 $INNOBACKUPEXFULL --defaults-file=$MY_CNF --use-memory=4G $MYSQL_CMD --incremental $NEW_INCRDIR --incremental-basedir $INCRBASEDIR > $TMPLOG 2>&1
 else
 echo "*********************************"
 echo -e "正在执行全新的完全备份...请稍等..."
echo "*********************************"
 $INNOBACKUPEXFULL --defaults-file=$MY_CNF --use-memory=4G $MYSQL_CMD $FULLBACKUP_DIR > $TMPLOG 2>&1
 fi
# --use-memory该参数在 prepare 的时候使用,控制 prepare 时 innodb 实例使用的内存量
 
 #保留一份备份的详细日志
 
cat $TMPLOG>/backup/$logfiledate
 
 
 
if [ -z "`tail -1 $TMPLOG | grep 'innobackupex: completed OK!'`" ] ; then
  echo "$INNOBACKUPEX命令执行失败:"; echo
  echo -e "---------- $INNOBACKUPEX_PATH错误 ----------"
  cat $TMPLOG
  rm -f $TMPLOG
  exit 1
 fi
 
 
 
THISBACKUP=`awk -- "/Backup created in directory/ { split( \\\$0, p, \"'\" ) ; print p[2] }" $TMPLOG`
 rm -f $TMPLOG
 
 
 
echo -n "数据库成功备份到:$THISBACKUP"
 echo
 
 
 
# 提示应该保留的备份文件起点
LATEST_FULL_BACKUP=`find $FULLBACKUP_DIR -mindepth 1 -maxdepth 1 -type d -printf "%P\n" | sort -nr | head -1`
 echo -e "必须保留$KEEP_FULLBACKUP份全备和全备$LATEST_FULL_BACKUP以后的所有增量备份."
 
 
 #删除过期的全备
echo -e "寻找过期的全备文件并删除">>/backup/$logfiledate
 for efile in $(/usr/bin/find $FULLBACKUP_DIR/ -mtime +6)
 do
  if [ -d $efile ]; then
  rm -rf $efile
  echo -e "删除过期全备文件:$efile" >>/backup/$logfiledate
  elif [ -f $efile ]; then
  rm -rf $file
  echo -e "删除过期全备文件:$efile" >>/backup/$logfiledate
  fi;
 
 done
 
if [ $? -eq "0" ];then
    echo
    echo -e "未找到可以删除的过期全备文件"
fi
 
 
 
echo
 echo "完成于: `date +%F' '%T'